//
//     videoInput
// http://muonics.net/school/spring05/videoInput/
//
// robocraft.ru
//

#include <cv.h>
#include <highgui.h>
#include <videoInput.h>

#ifdef _MSC_VER
//    MS VC
# pragma comment(lib, "cxcore200.lib")
# pragma comment(lib, "cv200.lib")
# pragma comment(lib, "highgui200.lib")
# pragma comment(lib, "videoInput.lib")
#endif //#ifdef _MSC_VER

IplImage* image = 0;

int main(int argc, char* argv[])
{
	//   videoInput
	videoInput VI;

	//    ,   
	int numDevices = VI.listDevices();
	int device1=0; //     

	//  
	VI.setIdealFramerate(device1, 15);

	//  
	VI.setupDevice(device1, 1280, 960, VI_COMPOSITE);

	//VI.showSettingsWindow(device1); //    

	//    
	image = cvCreateImage(cvSize(VI.getWidth(device1),VI.getHeight(device1)), IPL_DEPTH_8U, 3);

	cvNamedWindow("capture", CV_WINDOW_AUTOSIZE);

	while(1){
		if (VI.isFrameNew(device1)){
			//   -  
			//  -      
			//  - ,     B  R -
			//  - ,     
			VI.getPixels(device1, (unsigned char *)image->imageData, false, true); //    BGR

			//
			//      
			//    OpenCV
			//

			//  
			cvShowImage("capture", image);
		}

		char c = cvWaitKey(33);
		if (c == 27) { // ESC
			break;
		}
	}

	//  
	cvReleaseImage(&image);
	cvDestroyWindow("capture");

	//  
	VI.stopDevice(device1);

	return 0;
}
